/***************************************************************************
 *   X Equation Solver v.1.0						   *
 *   Copyright (C) DigitalCalamity Team  by S3ct0r  			   *
 *   s3ct0r@digitalcalamity.org   					   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <math.h>
#include <time.h>
#include <complex.h>

int min(int a,int b);
void solver();
void sleep( int time );
void about();

const char OS='M';

void get_garbage(){
	char garbage[100];
	fgets(garbage, 100, stdin);
}

int main(){
  
	char x;
START:
	printf("\n");
	printf("----X EQUATION SOLVER----\n");
	printf("-----------------------\n");
	printf("Options: \n");
	printf("1.Solve a (n by n) system of linear equations\n");
	printf("2.About\n");
	printf("3.Quit\n");
	printf("Enter option: "); scanf("%c",&x); 
	get_garbage();
	while ( (x != '1') && (x != '2') && (x != '3') ) {
		printf("Invalid option, re-enter: ");
		scanf("%c",&x); 
		get_garbage();
		
	}
	switch (x) {
		case '1': solver();
				break;		
		case '2': about();
				goto START;
				break;
		case '3': exit(1);
				break;			
	}
}
	
void solver() {

	int n,i,k,j,q,p,rank,*ipvt,*jpvt,x;	
	char buffer[1000];
	float **A,**L,*b,max,temp,sum;
	char *start, *end;
	end=NULL;

	printf("Enter the size of the equation system: "); scanf("%d",&n);
	if (n<1) {
		printf("Nothing to be done\n");
		printf("Quiting...\n");
		exit(1);
	}
	getchar();
	A=(float **)malloc((n+1)*sizeof(float *));
	if (A==NULL) {
		printf("**Cannot allocate the required RAM**\n");
		printf("quiting...\n");
		exit(1);
	}
	for (i=1;i<=n; i++ ) {
		A[i]=(float *)malloc((n+1)*sizeof(float));
		if (A[i]==NULL) {
			printf("**Cannot allocate the required RAM**\n");
			printf("quiting...\n");
			exit(1);
		}
	}
	k=1;
	while (k<=n) {
	  PREVIOUS:
	  printf("Input equation No%d: ",k);
	  fgets(buffer,sizeof(buffer),stdin);
	  start=buffer;
		  i=0;
		  while (buffer[i] != '\n' ) {
		    	if ( isalpha(buffer[i]) ) {
			   	  printf("Invalid input entered...\n");
				  printf("Re-enter the current equation\n");
				  goto PREVIOUS;
		
			    }
			    i++;
		  }
	   j=1;
	   A[k][j]=strtod(start,&end);
	   while ( (*end)!='\n' && j<=n ) {
		  start=end;
		  j++;
		  A[k][j]=strtod(start,&end);
	   }
	   k++;
	 }
	b=(float *)malloc((n+1)*sizeof(float));
	if (b==NULL) {
		printf("**Cannot allocate the required RAM**\n");
		printf("quiting...\n");
		for (i=0;i<=n;i++) 
			free(A[i]);
		free(A);
		exit(1);
	}
	printf("Enter right part: ");
	B:
	fgets(buffer,sizeof(buffer),stdin);
	start=buffer;
	end=NULL;
	i=0;
		while (buffer[i] != '\n' ) {
			if ( isalpha(buffer[i]) ) {
				printf("Invalid input entered...\n");
				printf("Re-enter the right part:");
				goto B;
		
			}
			i++;
		}
	j=1;
	b[j]=strtod(start,&end);
	while ( (*end)!='\n' && j<=n ) {
		start=end;
		j++;
		b[j]=strtod(start,&end);
	}
	printf("\n");
	printf("Calculating the solution");
				
	ipvt=(int *)malloc( (n+1) * sizeof(int) );
	if (ipvt==NULL) {
		printf("**Cannot allocate the required RAM**\n");
		printf("quiting...\n");
		for (i=0;i<=n;i++) 
			free(A[i]);
		free(b);
		exit(1);
	}
	jpvt=(int *)malloc( (n+1) * sizeof(int) );
	if (jpvt==NULL) {
		printf("**Cannot allocate the required RAM**\n");
		printf("quiting...\n");
		for (i=0;i<=n;i++) 
			free(A[i]);
		free(ipvt);
		free(b);
		exit(1);
	}
	for (i=0;i<=n;i++)
		jpvt[i]=0;
	for (i=0;i<=n;i++) {
		ipvt[i]=i;
	}
	k=0;
	rank=n;
	while (k < rank ) {
		printf(".");
		fflush(stdout);
		sleep(1);
		k=k+1;
		for (j=n-rank+k; j<=n; j++ ){
			p=k;
			max=cabs(A[k][j]);
			for (i=k+1;i<=n;i++) {
				if ( cabs(A[i][j])>max) {
					p=i;
					max=cabs(A[i][j]);
				}
			}
			if (max == 0 ) {
				rank=rank-1;
			}
			else {
				jpvt[j]=j;
				break;
			}
		}
		if (k <= rank) {
			if (p != k ) {
				for (q=1;q<=n;q++) {
					temp=A[k][q];
					A[k][q]=A[p][q];
					A[p][q]=temp;
				}
			}
			ipvt[k]=p;
			for (i=k+1;i<=n;i++) {
				A[i][k]=A[i][j]/A[k][j];
				if (k != j) {
					A[i][j]=0;
				}
				for (q=j+1;q<=n;q++) {
					A[i][q]=A[i][q]-A[i][k]*A[k][q];
				}
			}
		}
	}

	L=(float **)malloc((n+1)*sizeof(float *));
	if (L==NULL) {
		printf("**Cannot allocate the required RAM**\n");
		printf("quiting...\n");
		for (i=0;i<=n;i++)
			free(A[i]);
		free(ipvt); free(jpvt); free(b);
		exit(1);
	}
	for (i=1;i<=n; i++ ) {
		L[i]=(float *)malloc((n+1)*sizeof(float));
		if (L[i]==NULL) {
			printf("**Cannot allocate the required RAM**\n");
			printf("quiting...\n");
			for (i=0;i<=n;i++)
			free(A[i]);
			free(ipvt); free(jpvt); free(b);
			exit(1);
		}
	}
	for (i=1;i<=n;i++)
		for (j=1;j<=n;j++)
			if (i==j)
				L[i][j]=1;
			else
				L[i][j]=0;
	
	for (i=1;i<=n;i++)
		for (j=1;j<=n;j++) 
			if (i>j)
				L[i][j]=A[i][j];
	
	for (k=1;k<=n;k++) {
		p=ipvt[k];
		if (p != k) {
			temp=b[k];
			b[k]=b[p];
			b[p]=temp;
		}
	}

	for (i=1;i<=n;i++) {
		sum=0;
		for (k=1;k<=i-1;k++)
			sum=sum+L[i][k]*b[k];
		b[i]=b[i]-sum;
	}
		
	printf("done\n");
	
	if (rank<n) 
		printf("Warning: Rank deficient, rank = %d\n",rank);
		
	if ( rank<n ) 
		for (i=rank+1;i<=n;i++)
			if (b[i] != 0 ) {
				printf("The system of linear equations has no solution.\n");
				goto EXIT;
			}
			
	if (rank<n)	{
		
		float **new;
		new=(float **)malloc( (rank+1) * sizeof(float *) );
		if (new==NULL) {
			printf("**Cannot allocate the required RAM**\n");
			printf("quiting...\n");
			goto EXIT;
		}
		for (i=1;i<=rank;i++) {
			new[i]=(float *)malloc( (rank+1) *sizeof(float) );
			if (new[i]==NULL ){
				printf("**Cannot allocate the required RAM**\n");
				printf("quiting...\n");
				goto EXIT;
			}
		}
				
		for (i=1;i<=n;i++) {
			for (j=1;j<=n;j++)
				if (jpvt[j]==0)
					A[i][j]=RAND_MAX;
		}
		for (i=1;i<=rank;i++) {
			k=1;
			for (j=1;j<=n;j++) 
				if ( A[i][j] != RAND_MAX ) {
					new[i][k]=A[i][j];
					k++;
				}
		} 
		for (i=rank;i>=1;i--) {
			sum=0;
			for (j=i+1;j<=rank;j++)
				sum=sum+new[i][j]*b[j];
			b[i]=(b[i]-sum)/new[i][i];
			
		}
		printf("\nPrinting Results: \n");
		for (j=1;j<=n;j++) 
			if (jpvt[j]==0) {
				printf("X%d= 0.000\n",j);
				i=j;
			}
						
		for (j=1;j<=n;j++) {
			if (b[j]==0)
				continue;
			else 
				printf("X%d= %.3f\n",j,b[j]);
		}
				
		
		for (i=0;i<=rank;i++)
			free(new[i]);
		free(new);
		goto EXIT;
        		
	}
	
	if (n==1) {
		if (A[1][1]==0 && b[1] != 0) {
			printf("The system of linear equations has no solution.\n");
			goto EXIT;
		}
		else if ( A[1][1]==0 && b[1]==0) {
			printf("The system of linear equations has inf solutions\n");
			goto EXIT;
		}
	}
	
			
	for (i=n;i>=1;i--) {
		sum=0;
		for (k=i+1;k<=n;k++)
			sum=sum+A[i][k]*b[k];
		b[i]=(b[i]-sum)/A[i][i];
	}
	printf("\nPrinting Results: \n");
	for (i=1;i<=n;i++) {
		printf("X%d= %.3f\n",i,b[i]);
	}
	
EXIT:
	for (i=0;i<=n;i++) {
		free(A[i]);
		free(L[i]);
	}
	
	free(L);
	free(A);
	free(ipvt);
	free(b);
	free(jpvt);
}

void sleep(int time ){
	clock_t T;
	T=(time * CLOCKS_PER_SEC ) + clock();
	while (T>clock()){
		;
	}
}

void about() {
	printf("\n");
	printf("X Equation Solver version 1.0\n");
	printf("Coded by S3ct0r - s3ct0r@digitalcalamity.org\n");
	printf("A Digital Calamity Team Production \n");
	printf("www.digitalcalamity.org\n");
	printf("License: GNU GPL\n");
	printf("gcc version 4.1.0\n");
	printf("\n");
}


